package ports

import (
	"code.fbi.h-da.de/danet/gosdn/controller/store"
	topoStore "code.fbi.h-da.de/danet/gosdn/controller/topology/store"

	"go.mongodb.org/mongo-driver/mongo"
)

// NewPortStore returns a PortStore.
func NewPortStore(db *mongo.Database) Store {
	storeMode := store.GetStoreMode()

	switch storeMode {
	case store.Database:
		return NewDatabasePortStore(db)

	default:
		return topoStore.NewGenericStore[Port]()
	}
}
